#include "stdafx.h"
#include "LottoManCE.h"
#include "MainFrm.h"
#include "LottoManCEDoc.h"
#include "LottoManCEView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CLottoManCEApp, CWinApp)
	//{{AFX_MSG_MAP(CLottoManCEApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_COMMAND(ID_HELP, OnHelpIndex)
	ON_COMMAND(ID_HELP_SENDFEEDBACK, OnHelpSendfeedback)
	ON_COMMAND(ID_HELP_PRODUCTHOMEPAGE, OnHelpProducthomepage)
	ON_COMMAND(ID_HELP_AUTHORSHOMEPAGE, OnHelpAuthorshomepage)
	ON_COMMAND(ID_HELP_LOTTOHOMEPAGE, OnHelpLottohomepage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CLottoManCEApp::CLottoManCEApp()
	: CWinApp()
{
}

CLottoManCEApp theApp;

BOOL CLottoManCEApp::InitInstance()
{
	//Change the registry key under which our settings are stored.
	SetRegistryKey(_T("PJ Naughter"));

  //Initialise the MRU List
	LoadStdProfileSettings(4);

	//Register document templates
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CLottoManDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CLottoManView));
	AddDocTemplate(pDocTemplate);

	//Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	//Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}

void CLottoManCEApp::OnHelpIndex() 
{
  TCHAR pszPath[_MAX_PATH];
  GetModuleFileName(NULL, pszPath, _MAX_PATH);
  _tcscpy(pszPath + _tcslen(pszPath) - 4, _T(".HTM"));

  SHELLEXECUTEINFO sei;
  memset(&sei, 0, sizeof(sei));
  sei.cbSize = sizeof(sei);
  sei.lpVerb = _T("Open");
  sei.lpFile = pszPath;
  sei.hwnd = AfxGetMainWnd()->GetSafeHwnd();
  sei.nShow = SW_SHOW;
  ShellExecuteEx(&sei);
}

void CLottoManCEApp::OnHelpSendfeedback() 
{
  SHELLEXECUTEINFO sei;
  memset(&sei, 0, sizeof(sei));
  sei.cbSize = sizeof(sei);
  sei.lpVerb = _T("Open");
  sei.lpFile = _T("mailto:pjna@naughter.com");
  sei.hwnd = AfxGetMainWnd()->GetSafeHwnd();
  sei.nShow = SW_SHOW;
  ShellExecuteEx(&sei);
}

void CLottoManCEApp::OnHelpProducthomepage() 
{
  SHELLEXECUTEINFO sei;
  memset(&sei, 0, sizeof(sei));
  sei.cbSize = sizeof(sei);
  sei.lpVerb = _T("Open");
  sei.lpFile = _T("http://www.naughter.com/lottoman.html");
  sei.hwnd = AfxGetMainWnd()->GetSafeHwnd();
  sei.nShow = SW_SHOW;
  ShellExecuteEx(&sei);
}

void CLottoManCEApp::OnHelpAuthorshomepage() 
{
  SHELLEXECUTEINFO sei;
  memset(&sei, 0, sizeof(sei));
  sei.cbSize = sizeof(sei);
  sei.lpVerb = _T("Open");
  sei.lpFile = _T("http://www.naughter.com");
  sei.hwnd = AfxGetMainWnd()->GetSafeHwnd();
  sei.nShow = SW_SHOW;
  ShellExecuteEx(&sei);
}

void CLottoManCEApp::OnHelpLottohomepage() 
{
  SHELLEXECUTEINFO sei;
  memset(&sei, 0, sizeof(sei));
  sei.cbSize = sizeof(sei);
  sei.lpVerb = _T("Open");
  sei.lpFile = _T("http://www.lotto.ie");
  sei.hwnd = AfxGetMainWnd()->GetSafeHwnd();
  sei.nShow = SW_SHOW;
  ShellExecuteEx(&sei);
}








class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();		// Added for WCE apps
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CLottoManCEApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

BOOL CAboutDlg::OnInitDialog() 
{
  //Let the parent class do its thing
	CDialog::OnInitDialog();
	
	CenterWindow();
	
	return TRUE;
}

