#ifndef __LOTTOMANDOC_H__
#define __LOTTOMANDOC_H__


class CMember : public CObject
{
public:
//Constructors / Destructors
 CMember();
 CMember(const CMember& member);
 ~CMember();

//Methods
 CMember& operator=(const CMember& member);
 virtual void Serialize(CArchive& ar);

//Data (just left public for simplicity reasons)
	CString      m_sName;
  int          m_nNumbers[6];
  BOOL         m_bEnabled;

	//Non-Persistant
	BOOL m_bMarkedForDeletion;
};


class CLottoManDoc : public CDocument
{
protected: // create from serialization only
	CLottoManDoc();
	DECLARE_DYNCREATE(CLottoManDoc)

	//{{AFX_VIRTUAL(CLottoManDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

public:
	virtual ~CLottoManDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

  void MarkMemberAsDeleted(int nIndex);
  int NumberOfMembers() const;
  CString CreateUniqueMemberName() const;
  BOOL DoesMemberNameExist(const CString& sName, int nExistingIndex) const;
  CMember* GetAtMember(int nMemberNum) const;

  //Serialized member variables
  CArray<CMember*, CMember*&> m_Members;
  int m_nListViewStyle;

protected:
  void FreeAllMemory();

	//{{AFX_MSG(CLottoManDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //__LOTTOMANDOC_H__