#include "stdafx.h"
#include "LottoManCE.h"
#include "MemberUI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CMemberPage, CDialog)

CMemberPage::CMemberPage() : CDialog(CMemberPage::IDD)
{
	//{{AFX_DATA_INIT(CMemberPage)
	m_sName = _T("");
	m_nNum1 = 0;
	m_nNum2 = 0;
	m_nNum3 = 0;
	m_nNum4 = 0;
	m_nNum5 = 0;
	m_nNum6 = 0;
	m_bEnabled = FALSE;
	//}}AFX_DATA_INIT
  m_bEnabled = TRUE;
	m_nMemberIndex = -1;
  m_pDoc = NULL;
}

CMemberPage::~CMemberPage()
{
}

void CMemberPage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMemberPage)
	DDX_Control(pDX, IDC_NAME, m_ctrlName);
	DDX_Text(pDX, IDC_NAME, m_sName);
	DDX_Text(pDX, IDC_NUM1, m_nNum1);
	DDV_MinMaxInt(pDX, m_nNum1, 1, 42);
	DDX_Text(pDX, IDC_NUM2, m_nNum2);
	DDV_MinMaxInt(pDX, m_nNum2, 1, 42);
	DDX_Text(pDX, IDC_NUM3, m_nNum3);
	DDV_MinMaxInt(pDX, m_nNum3, 1, 42);
	DDX_Text(pDX, IDC_NUM4, m_nNum4);
	DDV_MinMaxInt(pDX, m_nNum4, 1, 42);
	DDX_Text(pDX, IDC_NUM5, m_nNum5);
	DDV_MinMaxInt(pDX, m_nNum5, 1, 42);
	DDX_Text(pDX, IDC_NUM6, m_nNum6);
	DDV_MinMaxInt(pDX, m_nNum6, 1, 42);
	DDX_Check(pDX, IDC_ENABLED, m_bEnabled);
	//}}AFX_DATA_MAP

  ASSERT(m_pDoc);

	if (pDX->m_bSaveAndValidate)
	{
		if (m_sName.GetLength() == 0)
		{
			AfxMessageBox(IDS_NEED_NONEMPTY_STRING);
			pDX->PrepareEditCtrl(IDC_NAME);
			pDX->Fail();
		}
		else if (m_pDoc->DoesMemberNameExist(m_sName, m_nMemberIndex))
		{
			AfxMessageBox(IDS_RENAME_UNIQUE_MEMBERNAME);
			pDX->PrepareEditCtrl(IDC_NAME);
			pDX->Fail();
		}

    //Check all numbers are unique
	  BOOL bIsUnique = (m_nNum1 != m_nNum2) && (m_nNum1 != m_nNum3) && (m_nNum1 != m_nNum4) && (m_nNum1 != m_nNum5) && (m_nNum1 != m_nNum6);
	  bIsUnique = bIsUnique && (m_nNum2 != m_nNum3) && (m_nNum2 != m_nNum4) && (m_nNum2 != m_nNum5) && (m_nNum2 != m_nNum6);
	  bIsUnique = bIsUnique && (m_nNum3 != m_nNum4) && (m_nNum3 != m_nNum5) && (m_nNum3 != m_nNum6);
	  bIsUnique = bIsUnique && (m_nNum4 != m_nNum5) && (m_nNum4 != m_nNum6);
	  bIsUnique = bIsUnique && (m_nNum5 != m_nNum6);
    if (!bIsUnique)
		{
			AfxMessageBox(IDS_NEED_UNIQUE_NUMBERS);
			pDX->PrepareEditCtrl(IDC_NUM1);
			pDX->Fail();
		}
	}
}

BEGIN_MESSAGE_MAP(CMemberPage, CDialog)
	//{{AFX_MSG_MAP(CMemberPage)
	ON_EN_CHANGE(IDC_NAME, OnChangeName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CMemberPage::OnChangeName() 
{
	CString sName;
	GetDlgItemText(IDC_NAME, sName);
	CString sCaption;
	AfxFormatString1(sCaption, IDS_PROPERTIES_FOR, sName);
	SetWindowText(sCaption);
}

CMember CMemberPage::GetMember() const
{
  CMember member;

	member.m_sName = m_sName;
  member.m_nNumbers[0] = m_nNum1;
  member.m_nNumbers[1] = m_nNum2;
  member.m_nNumbers[2] = m_nNum3;
  member.m_nNumbers[3] = m_nNum4;
  member.m_nNumbers[4] = m_nNum5;
  member.m_nNumbers[5] = m_nNum6;
  member.m_bEnabled =    m_bEnabled;

  return member;
}

void CMemberPage::SetMember(const CMember& member)
{
	m_sName = member.m_sName;
  m_nNum1 = member.m_nNumbers[0];
  m_nNum2 = member.m_nNumbers[1];
  m_nNum3 = member.m_nNumbers[2];
  m_nNum4 = member.m_nNumbers[3];
  m_nNum5 = member.m_nNumbers[4];
  m_nNum6 = member.m_nNumbers[5];
  m_bEnabled = member.m_bEnabled;
}



