#include "stdafx.h"
#include "LottomanCE.h"
#include "ResultsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int NUM_BALLS_DRAWN = 7;
const int NUM_BALLS_PICKED = 6;

struct OneLine
{
  int Numbers[NUM_BALLS_PICKED];
};

class CLineResult
{
public:
  CLineResult() { nWinningBalls = 0; bBonusBall = FALSE; };

  int nWinningBalls;
  BOOL bBonusBall;
};


CResultsDlg::CResultsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResultsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResultsDlg)
	m_nNum1 = 0;
	m_nNum2 = 0;
	m_nNum3 = 0;
	m_nNum4 = 0;
	m_nNum5 = 0;
	m_nNum6 = 0;
	m_nNum7 = 0;
	//}}AFX_DATA_INIT
  m_pDoc = NULL;
}

void CResultsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResultsDlg)
	DDX_Control(pDX, IDC_RESULTS, m_ctrlResults);
	DDX_Text(pDX, IDC_RESNUM1, m_nNum1);
	DDV_MinMaxInt(pDX, m_nNum1, 1, 42);
	DDX_Text(pDX, IDC_RESNUM2, m_nNum2);
	DDV_MinMaxInt(pDX, m_nNum2, 1, 42);
	DDX_Text(pDX, IDC_RESNUM3, m_nNum3);
	DDV_MinMaxInt(pDX, m_nNum3, 1, 42);
	DDX_Text(pDX, IDC_RESNUM4, m_nNum4);
	DDV_MinMaxInt(pDX, m_nNum4, 1, 42);
	DDX_Text(pDX, IDC_RESNUM5, m_nNum5);
	DDV_MinMaxInt(pDX, m_nNum5, 1, 42);
	DDX_Text(pDX, IDC_RESNUM6, m_nNum6);
	DDV_MinMaxInt(pDX, m_nNum6, 1, 42);
	DDX_Text(pDX, IDC_RESNUM7, m_nNum7);
	DDV_MinMaxInt(pDX, m_nNum7, 1, 42);
	//}}AFX_DATA_MAP

  if (pDX->m_bSaveAndValidate)
  {
    //Check all numbers are unique
	  BOOL bIsUnique = (m_nNum1 != m_nNum2) && (m_nNum1 != m_nNum3) && (m_nNum1 != m_nNum4) && (m_nNum1 != m_nNum5) && (m_nNum1 != m_nNum6) && (m_nNum1 != m_nNum7);
	  bIsUnique = bIsUnique && (m_nNum2 != m_nNum3) && (m_nNum2 != m_nNum4) && (m_nNum2 != m_nNum5) && (m_nNum2 != m_nNum6) && (m_nNum2 != m_nNum7);
	  bIsUnique = bIsUnique && (m_nNum3 != m_nNum4) && (m_nNum3 != m_nNum5) && (m_nNum3 != m_nNum6) && (m_nNum3 != m_nNum7);
	  bIsUnique = bIsUnique && (m_nNum4 != m_nNum5) && (m_nNum4 != m_nNum6) && (m_nNum4 != m_nNum7);
	  bIsUnique = bIsUnique && (m_nNum5 != m_nNum6) && (m_nNum5 != m_nNum7);
    bIsUnique = bIsUnique && (m_nNum6 != m_nNum7);
    if (!bIsUnique)
		{
			AfxMessageBox(IDS_NEED_UNIQUE_NUMBERS);
			pDX->PrepareEditCtrl(IDC_RESNUM1);
			pDX->Fail();
		}
  }
}

BEGIN_MESSAGE_MAP(CResultsDlg, CDialog)
	//{{AFX_MSG_MAP(CResultsDlg)
	ON_BN_CLICKED(IDC_CHECK, OnCheck)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CResultsDlg::OnCheck() 
{
  if (!UpdateData(TRUE))
     return;

  int ThisWeeksNumbers[NUM_BALLS_DRAWN];
	ThisWeeksNumbers[0] = m_nNum1;
	ThisWeeksNumbers[1] = m_nNum2;
	ThisWeeksNumbers[2] = m_nNum3;
  ThisWeeksNumbers[3] = m_nNum4;
	ThisWeeksNumbers[4] = m_nNum5;
	ThisWeeksNumbers[5] = m_nNum6;
	ThisWeeksNumbers[6] = m_nNum7;

  ASSERT(m_pDoc);
  int NUM_LINES = m_pDoc->NumberOfMembers();

  //Set up the OurNumbers array
  OneLine* pOurNumbers = new OneLine[NUM_LINES];
  for (int i=0; i<NUM_LINES; i++)
  {
    CMember* pMember = m_pDoc->GetAtMember(i);

    pOurNumbers[i].Numbers[0] = pMember->m_nNumbers[0];
    pOurNumbers[i].Numbers[1] = pMember->m_nNumbers[1];
    pOurNumbers[i].Numbers[2] = pMember->m_nNumbers[2];
    pOurNumbers[i].Numbers[3] = pMember->m_nNumbers[3];
    pOurNumbers[i].Numbers[4] = pMember->m_nNumbers[4];
    pOurNumbers[i].Numbers[5] = pMember->m_nNumbers[5];
  }

  //Check the Results
  CLineResult* pWinningLines = new CLineResult[NUM_LINES];
  for (i=0; i<NUM_LINES; i++)
  {
    CMember* pMember = m_pDoc->GetAtMember(i);
    if (pMember->m_bEnabled)
    {
      for (int j=0; j<NUM_BALLS_DRAWN-1; j++)
      {
        for (int k=0; k<NUM_BALLS_PICKED; k++)
        {
          if (pOurNumbers[i].Numbers[j] == ThisWeeksNumbers[k])
            pWinningLines[i].nWinningBalls++;
        }
      }
      for (j=0; j<NUM_BALLS_PICKED; j++)
      {
        if (pOurNumbers[i].Numbers[j] == ThisWeeksNumbers[NUM_BALLS_DRAWN-1])
          pWinningLines[i].bBonusBall = TRUE;
      }
    }
  }


  //Tally the Results
  int nNumOnes = 0;
  int nNumTwos = 0;
  int nNumThrees = 0;
  int nNumThreesPlusBonus = 0;
  int nNumFours = 0;
  int nNumFoursPlusBonus = 0;
  int nNumFives = 0;
  int nNumFivesPlusBonus = 0;
  int nNumJackpots = 0;
  for (i=0; i<NUM_LINES; i++)
  {
    if (pWinningLines[i].nWinningBalls == 6)
      ++nNumJackpots;
    else if (pWinningLines[i].nWinningBalls == 5 && pWinningLines[i].bBonusBall)
      ++nNumFivesPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 5)
      ++nNumFives;
    else if (pWinningLines[i].nWinningBalls == 4 && pWinningLines[i].bBonusBall)
      ++nNumFoursPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 4)
      ++nNumFours;
    else if (pWinningLines[i].nWinningBalls == 3 && pWinningLines[i].bBonusBall)
      ++nNumThreesPlusBonus;
    else if (pWinningLines[i].nWinningBalls == 3)
      ++nNumThrees;
    else if (pWinningLines[i].nWinningBalls == 2)
      ++nNumTwos;
    else if (pWinningLines[i].nWinningBalls == 1)
      ++nNumOnes;
  }

  //Display the results in the edit control
  CString sWindowText;

  CString sText;
  sText.Format(_T("We have %d Match 1's\r\n"), nNumOnes);
  sWindowText += sText;

  sText.Format(_T("We have %d Match 2's\r\n"), nNumTwos);
  sWindowText += sText;

  if (nNumThrees)
  {
    sText.Format(_T("We have %d Match 3 WINNING tickets (if this draw is for Lotto Plus)\r\n"), nNumThrees);
    sWindowText += sText;
  }
  if (nNumThreesPlusBonus)
  {
    sText.Format(_T("We have %d Match 3 plus bonus WINNING tickets\r\n"), nNumThreesPlusBonus);
    sWindowText += sText;
  }
  if (nNumFours)
  {
    sText.Format(_T("We have %d Match 4 WINNING tickets\r\n"), nNumFours);
    sWindowText += sText;
  }
  if (nNumFoursPlusBonus)
  {
    sText.Format(_T("We have %d Match 4 plus bonus WINNING tickets\r\n"), nNumFoursPlusBonus);
    sWindowText += sText;
  }
  if (nNumFives)
  {
    sText.Format(_T("We have %d Match 5 WINNING tickets\r\n"), nNumFives);
    sWindowText += sText;
  }
  if (nNumFivesPlusBonus)
  {
    sText.Format(_T("We have %d Match 5 plus bonus WINNING tickets\r\n"), nNumFivesPlusBonus);
    sWindowText += sText;
  }
  if (nNumJackpots)
  {
    sText.Format(_T("We have WON THE JACKPOT, Time to celebrate\r\n"), nNumJackpots);
    sWindowText += sText;
  }

  //Iterate through all the tickers and display the names of those winning tickets
  sWindowText += "\r\n";
  for (i=0; i<NUM_LINES; i++)
  {
    CMember* pMember = m_pDoc->GetAtMember(i);
    if (pWinningLines[i].nWinningBalls == 6)
    {
      sText.Format(_T("%s had a Jackpot WINNING ticket\r\n"), pMember->m_sName);
      sWindowText += sText;
    }
    else if (pWinningLines[i].nWinningBalls == 5 && pWinningLines[i].bBonusBall)
    {
      sText.Format(_T("%s had a Match 5 plus bonus WINNING ticket\r\n"), pMember->m_sName);
      sWindowText += sText;
    }
    else if (pWinningLines[i].nWinningBalls == 5)
    {
      sText.Format(_T("%s had a Match 5 WINNING ticket\r\n"), pMember->m_sName);
      sWindowText += sText;
    }
    else if (pWinningLines[i].nWinningBalls == 4 && pWinningLines[i].bBonusBall)
    {
      sText.Format(_T("%s had a Match 4 plus bonus WINNING ticket\r\n"), pMember->m_sName);
      sWindowText += sText;
    }
    else if (pWinningLines[i].nWinningBalls == 4)
    {
      sText.Format(_T("%s had a Match 4 WINNING ticket\r\n"), pMember->m_sName);
      sWindowText += sText;
    }
    else if (pWinningLines[i].nWinningBalls == 3 && pWinningLines[i].bBonusBall)
    {
      sText.Format(_T("%s had a Match 3 plus bonus WINNING ticket\r\n"), pMember->m_sName);
      sWindowText += sText;
    }
    else if (pWinningLines[i].nWinningBalls == 3)
    {
      sText.Format(_T("%s had a Match 3 Potential WINNING ticket\r\n"), pMember->m_sName);
      sWindowText += sText;
    }
    /*
    else if (pWinningLines[i].nWinningBalls == 2)
    {
      sText.Format("%s had a Match 2 ticket\r\n", pMember->m_sName);
      sWindowText += sText;
    }
    else if (pWinningLines[i].nWinningBalls == 1)
    {
      sText.Format("%s had a Match 1 ticket\r\n", pMember->m_sName);
      sWindowText += sText;
    }
    */
  }

  //Delete the memory we allocated
  delete [] pWinningLines;
  delete [] pOurNumbers;

  //Display the results in the edit control
  m_ctrlResults.SetWindowText(sWindowText);
}

